import 'package:lori_sdk/data/database/notificationDaoStub.dart';
// ignore: uri_does_not_exist // this will work on mobile but will not work on web
import 'package:lori_sdk/data/models/notification.dart';

abstract class NotificationDao {
  Future open() async {}

  Future<void> insertOrUpdate(Notification notification) async {}

  Future<void> insert(Notification notification) async {}

  Future<void> update(Notification notification) async {}

  Future<void> updateByText(Notification notification) async {}

  // ignore: missing_return
  Future<List<Notification>> get(bool isRead) async {}

  // ignore: missing_return
  Future<Notification> getByText(String title, String body) async {}

  // ignore: missing_return
  Future<Notification> getById(int id) async {}

  Future<void> deleteAll() async {}

  factory NotificationDao() => getNotificationDao();
}
