class Buyer {
  Buyer({
    this.id,
    this.phoneNumber,
    this.userName,
    this.normalizedUserName,
    this.emailConfirmed,
    this.phoneNumberConfirmed,
    this.twoFactorEnabled,
    this.lockOutEnabled,
    this.accessFailedCount,
    this.acceptedUserTerms,
    this.acceptedPromotionPolicy,
    this.isActive,
    this.addressId,
    this.address,
    this.gender,
    this.cpf,
    this.dateOfBirth,
    this.companyName,
    this.cnpj,
    this.fullName,
    this.email,
    this.normalizedEmail,
    this.password,
    this.newPassword,
    this.facebookId,
    this.facebookToken,
    this.googleId,
    this.googleToken,
    this.imageUrl,
    this.clientId,
    this.isDeleted,
    this.createDate,
  });

  String id;
  String phoneNumber;
  String userName;
  String normalizedUserName;
  bool emailConfirmed;
  bool phoneNumberConfirmed;
  bool twoFactorEnabled;
  bool lockOutEnabled;
  int accessFailedCount;
  bool acceptedUserTerms;
  bool acceptedPromotionPolicy;
  bool isActive;
  dynamic addressId;
  List<dynamic> address;
  int gender;
  String cpf;
  DateTime dateOfBirth;
  dynamic companyName;
  dynamic cnpj;
  String fullName;
  String email;
  String normalizedEmail;
  dynamic password;
  dynamic newPassword;
  dynamic facebookId;
  dynamic facebookToken;
  dynamic googleId;
  dynamic googleToken;
  dynamic imageUrl;
  String clientId;
  bool isDeleted;
  DateTime createDate;

  factory Buyer.fromJson(Map<String, dynamic> json) {
    List<dynamic> _address;
    // TODO DC-627 o endereco quando finaliza a compra vem como map(tem que verificar porque)
    // temporariamente eu vou deixar o endereco como null se ele vir como map
    if (json != null && json["address"] != null && (json['address'] is List)) {
      _address = List<dynamic>.from(json["address"].map((x) => x));
    }

    return json == null
        ? null
        : Buyer(
            id: json["id"] == null ? null : json["id"],
            phoneNumber: json["phoneNumber"] == null ? null : json["phoneNumber"],
            userName: json["userName"] == null ? null : json["userName"],
            normalizedUserName: json["normalizedUserName"] == null ? null : json["normalizedUserName"],
            emailConfirmed: json["emailConfirmed"] == null ? null : json["emailConfirmed"],
            phoneNumberConfirmed: json["phoneNumberConfirmed"] == null ? null : json["phoneNumberConfirmed"],
            twoFactorEnabled: json["twoFactorEnabled"] == null ? null : json["twoFactorEnabled"],
            lockOutEnabled: json["lockOutEnabled"] == null ? null : json["lockOutEnabled"],
            accessFailedCount: json["accessFailedCount"] == null ? null : json["accessFailedCount"],
            acceptedUserTerms: json["acceptedUserTerms"] == null ? null : json["acceptedUserTerms"],
            acceptedPromotionPolicy: json["acceptedPromotionPolicy"] == null ? null : json["acceptedPromotionPolicy"],
            isActive: json["isActive"] == null ? null : json["isActive"],
            addressId: json["addressId"],
            address: _address ?? null,
            gender: json["gender"] == null ? null : json["gender"],
            cpf: json["cpf"] == null ? null : json["cpf"],
            dateOfBirth: json["dateOfBirth"] == null ? null : DateTime.parse(json["dateOfBirth"]),
            companyName: json["companyName"],
            cnpj: json["cnpj"],
            fullName: json["fullName"] == null ? null : json["fullName"],
            email: json["email"] == null ? null : json["email"],
            normalizedEmail: json["normalizedEmail"] == null ? null : json["normalizedEmail"],
            password: json["password"],
            newPassword: json["newPassword"],
            facebookId: json["facebookId"],
            facebookToken: json["facebookToken"],
            googleId: json["googleId"],
            googleToken: json["googleToken"],
            imageUrl: json["imageUrl"],
            clientId: json["clientId"] == null ? null : json["clientId"],
            isDeleted: json["isDeleted"] == null ? null : json["isDeleted"],
            createDate: json["createDate"] == null ? null : DateTime.parse(json["createDate"]),
          );
  }

  Map<String, dynamic> toJson() => {
        "id": id == null ? null : id,
        "phoneNumber": phoneNumber == null ? null : phoneNumber,
        "userName": userName == null ? null : userName,
        "normalizedUserName": normalizedUserName == null ? null : normalizedUserName,
        "emailConfirmed": emailConfirmed == null ? null : emailConfirmed,
        "phoneNumberConfirmed": phoneNumberConfirmed == null ? null : phoneNumberConfirmed,
        "twoFactorEnabled": twoFactorEnabled == null ? null : twoFactorEnabled,
        "lockOutEnabled": lockOutEnabled == null ? null : lockOutEnabled,
        "accessFailedCount": accessFailedCount == null ? null : accessFailedCount,
        "acceptedUserTerms": acceptedUserTerms == null ? null : acceptedUserTerms,
        "acceptedPromotionPolicy": acceptedPromotionPolicy == null ? null : acceptedPromotionPolicy,
        "isActive": isActive == null ? null : isActive,
        "addressId": addressId,
        "address": address == null ? null : List<dynamic>.from(address.map((x) => x)),
        "gender": gender == null ? null : gender,
        "cpf": cpf == null ? null : cpf,
        "dateOfBirth": dateOfBirth == null ? null : dateOfBirth.toIso8601String(),
        "companyName": companyName,
        "cnpj": cnpj,
        "fullName": fullName == null ? null : fullName,
        "email": email == null ? null : email,
        "normalizedEmail": normalizedEmail == null ? null : normalizedEmail,
        "password": password,
        "newPassword": newPassword,
        "facebookId": facebookId,
        "facebookToken": facebookToken,
        "googleId": googleId,
        "googleToken": googleToken,
        "imageUrl": imageUrl,
        "clientId": clientId == null ? null : clientId,
        "isDeleted": isDeleted == null ? null : isDeleted,
        "createDate": createDate == null ? null : createDate.toIso8601String(),
      };

  @override
  String toString() => toJson().toString();
}
