import 'package:lori_sdk/data/models/configurations/brandConfigurations.dart';
import 'package:lori_sdk/data/models/configurations/complementaryNameProduct.dart';
import 'package:lori_sdk/data/models/configurations/orderCodeType.dart';
import 'package:lori_sdk/data/models/configurations/whatsapp_configurations.dart';
import 'package:lori_sdk/data/models/product/productOrder.dart';
import 'package:lori_sdk/data/models/trustDefenderConfiguration.dart';

part 'configurations.g.dart';

class Configurations {
  Configurations();

  bool enableCRMPropz;
  bool useBonus;
  bool showUnavailableProducts;
  int minStock;
  int daysIsNewRole;
  String apiVersion;
  bool showSkuSelector;
  bool enableWholesalePrice;

  bool enablePickupOnlyCartMessage;

  String pickupOnlyCartMessage;

  bool hasDealerCode;

  bool showReaderCodeBar;

  bool isSinglePrice;

  bool enableSDKCybersource;

  double displayRadius;

  bool isShowSubCategories = false;

  ProductOrder catalogSort;

  bool buyWithOneClick;

  String checkoutPaymentAlertText;

  bool forceSellerNameAtList;

  String productDisplayCodeName;

  bool enableUserPromotion;

  bool enableWhatsappButton;

  double minAmountPurchase;

  bool isMinAmountTotalPurchase;

  String whatsappPhoneNumber;
  String whatsappMessage;

  OrderCodeType showOrderCodeType;

  BrandConfigurations brandConfigurations;

  TrustDefenderConfiguration trustDefenderConfiguration;

  String clearSaleAppKey;

  /// Those variables here are only to help with formatting
  WhatsappConfigurations whatsapp;

  ComplementaryNameProduct showComplementaryNameOnProductList;

  ComplementaryNameProduct showComplementaryNameOnProductDetail;

  factory Configurations.fromJson(Map<String, dynamic> json) {
    var configurations = _$ConfigurationsFromJson(json);
    // Whatsapp Configurations
    if (configurations.enableWhatsappButton) {
      configurations.whatsapp = WhatsappConfigurations(
          number: configurations.whatsappPhoneNumber,
          message: configurations.whatsappMessage);
    }
    return configurations;
  }

  Map<String, dynamic> toJson() => _$ConfigurationsToJson(this);
}
