enum ProductOrder {
  none,

  lowestPrice,

  higherPrice,

  mostFavored,

  bestSellers,

  releaseDate,

  aToZ,

  zToA
}

extension ProductOrderName on ProductOrder {
  String get parameterName {
    switch (this) {
      case ProductOrder.none:
        return null;
      case ProductOrder.lowestPrice:
        return "LowestPrice";
      case ProductOrder.higherPrice:
        return "HigherPrice";
      case ProductOrder.mostFavored:
        return "MostFavored";
      case ProductOrder.bestSellers:
        return "BestSellers";
      case ProductOrder.releaseDate:
        return "ReleaseDate";
      case ProductOrder.aToZ:
        return "AtoZ";
      case ProductOrder.zToA:
        return "ZtoA";
      default:
        return null;
    }
  }

  String get displayName {
    switch (this) {
      case ProductOrder.none:
        return "Relevância";
      case ProductOrder.lowestPrice:
        return "Menor preço";
      case ProductOrder.higherPrice:
        return "Maior preço";
      case ProductOrder.mostFavored:
        return "Mais favoritados";
      case ProductOrder.bestSellers:
        return "Mais vendidos";
      case ProductOrder.releaseDate:
        return "Mais novos";
      case ProductOrder.aToZ:
        return "A - Z";
      case ProductOrder.zToA:
        return "Z - A";
      default:
        return null;
    }
  }
}
